
-- VHDL Test Bench Created from source file sqrt.vhd -- Fri Mar 09 15:29:51 2012

--
-- Notes: 
-- 1) This testbench template has been automatically generated using types
-- std_logic and std_logic_vector for the ports of the unit under test.
-- Lattice recommends that these types always be used for the top-level
-- I/O of a design in order to guarantee that the testbench will bind
-- correctly to the timing (post-route) simulation model.
-- 2) To use this template as your testbench, change the filename to any
-- name of your choice with the extension .vhd, and use the "source->import"
-- menu in the ispLEVER Project Navigator to import the testbench.
-- Then edit the user defined section below, adding code to generate the 
-- stimulus for your design.
-- 3) VHDL simulations will produce errors if there are Lattice FPGA library 
-- elements in your design that require the instantiation of GSR, PUR, and
-- TSALL and they are not present in the testbench. For more information see
-- the How To section of online help.  
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE behavior OF testbench IS 

	COMPONENT sqrt
	PORT(
		RST : IN std_logic;
		CLK : IN std_logic;
		DTEN : IN std_logic;
		DTIN : IN std_logic_vector(63 downto 0);          
		DTOUT : OUT std_logic_vector(63 downto 0);
		DTOUT_VLD : OUT std_logic;
		BUSY : OUT std_logic
		);
	END COMPONENT;

	SIGNAL RST :  std_logic:='1';
	SIGNAL CLK :  std_logic:='0';
	SIGNAL DTEN :  std_logic:='0';
	SIGNAL DTIN :  std_logic_vector(63 downto 0):=X"0000_0000_0000_0000";
	SIGNAL DTOUT :  std_logic_vector(63 downto 0);
	SIGNAL DTOUT_VLD :  std_logic;
	SIGNAL BUSY :  std_logic;
	
	constant cDTIN_1			:std_logic_vector(63 downto 0):=X"0000_0000_0000_0001";
	constant cDTIN_2			:std_logic_vector(63 downto 0):=X"0000_0000_0000_0002";
	constant cDTIN_3			:std_logic_vector(63 downto 0):=X"0000_0000_0000_0003";
	constant cDTIN_4			:std_logic_vector(63 downto 0):=X"0000_0000_0000_0004";
	constant cDTIN_1073741824	:std_logic_vector(63 downto 0):=X"0000_0000_4000_0000";
	
	
BEGIN

-- Please check and add your generic clause manually
	uut: sqrt PORT MAP(
		RST => RST,
		CLK => CLK,
		DTEN => DTEN,
		DTIN => DTIN,
		DTOUT => DTOUT,
		DTOUT_VLD => DTOUT_VLD,
		BUSY => BUSY
	);


-- *** Test Bench - User Defined Section ***
	--Zbg
	process
	begin
	wait for 20 ns;
		RST <= '0';
	wait;
	end process;
	--NbN
	process
	begin
	wait for 5 ns;
		CLK <= not CLK;
	end process;
	--f[^
	process
	begin
	wait for 100ns;
		wait until CLK = '1';
			DTEN <= '1';
			DTIN <= cDTIN_1;
		wait until CLK = '1';
			DTEN <= '0';
		wait until BUSY = '0';
		wait until CLK = '1';
			DTEN <= '1';
			DTIN <= cDTIN_2;
		wait until CLK = '1';
			DTEN <= '0';
		wait until BUSY = '0';
		wait until CLK = '1';
			DTEN <= '1';
			DTIN <= cDTIN_3;
		wait until CLK = '1';
			DTEN <= '0';
		wait until BUSY = '0';
		wait until CLK = '1';
			DTEN <= '1';
			DTIN <= cDTIN_4;
		wait until CLK = '1';
			DTEN <= '0';
		wait until BUSY = '0';
		wait until CLK = '1';
			DTEN <= '1';
			DTIN <= cDTIN_1073741824;
		wait until CLK = '1';
			DTEN <= '0';
		
	wait;
	end process;
	
	
	
END;
